#include "locmin.h"
#include <bits/stdc++.h>
#define NMAX 500
using namespace std;

long long val[NMAX+1][NMAX+1];
int dx[4]={-1, 0, 1, 0};
int dy[4]={0, -1, 0, 1};

std::pair <int, int> find_locmin_point(int N, int M) {

    int n=N, m=M;
    pair<int, int> pos_min;
    pos_min={n, m};
    val[n][m]=value(n, m);
    while(true)
    {
        bool ok=1;
        for(int d=0; d<4; d++)
        {
            int x=pos_min.first+dx[d], y=pos_min.second+dy[d];
            if(x>=1 && x<=n && y>=1 && y<=m)
            {
                if(val[x][y]==0) val[x][y]=value(x, y);
                if(val[x][y]<val[pos_min.first][pos_min.second])
                {
                    pos_min={x, y};
                    ok=0;
                    break;
                }
            }
        }
        if(ok) return pos_min;
    }
}